<?php
	
	/********************************************************************/
	/* z񂩂IuWFNgւ̕ϊ                                     */
	/********************************************************************/
	
	#MantisConnectIssueData
	#MantisThriftIssueDataIuWFNgɕϊ
	function mti_parse_array_to_IssueData($issue) {
		
		#f[^̓]s
		$result = new IssueData();
		
		$result->id = $issue['id'];
		$result->view_state = mti_convert_to_objectref($issue['view_state']);
		$result->last_updated = $issue['last_updated'];
		
		$result->project = mti_convert_to_objectref($issue['project']);
		$result->category = $issue['category'];
		$result->priority = mti_convert_to_objectref($issue['priority']);
		$result->severity = mti_convert_to_objectref($issue['severity']);
		$result->status = mti_convert_to_objectref($issue['status']);
		
		$result->reporter = mti_convert_to_accountdata($issue['reporter']);
		$result->summary = $issue['summary'];
		$result->version = $issue['version'];
		$result->build = $issue['build'];
		$result->platform = $issue['platform'];
		$result->os = $issue['os'];
		$result->os_build = $issue['os_build'];
		$result->reproducibility = mti_convert_to_objectref($issue['reproducibility']);
		$result->date_submitted = $issue['date_submitted'];
		
		$result->sponsorship_total = $issue['sponsorship_total'];
		
		if (!empty( $issue['handler'])) {
			$result->handler = mti_convert_to_accountdata($issue['handler']);
		}
		$result->projection = mti_convert_to_objectref($issue['projection']);
		$result->eta = mti_convert_to_objectref($issue['eta']);
		
		$result->resolution = mti_convert_to_objectref($issue['resolution']);
		$result->fixed_in_version = $issue['fixed_in_version'];
		
		$result->description = $issue['description'];
		$result->steps_to_reproduce = $issue['steps_to_reproduce'];
		$result->additional_information = $issue['additional_information'];
		
		$result->attachments = mti_explode_to_attachment($issue['attachments']);
		$result->relationships = mti_explode_to_relationships($issue['relationships']);
		$result->notes = mti_explode_to_issuenotedata($issue['notes']);
		if (!empty($issue['custom_fields'])) {
			$result->custom_fields = mti_explode_to_custom_field($issue['custom_fields']);
		}
		
		return $result;
	}
	
	//z񂩂ObjectRef̌`ɕϊ
	function mti_convert_to_objectref($ary) {
		$obj = new ObjectRef();
		$obj->id = $ary['id'];
		$obj->name = $ary['name'];
		return $obj;
	}
	
	//z񂩂AccountDatǎ`ɕϊ
	function mti_convert_to_accountdata($ary) {
		$obj = new AccountData();
		$obj->id = $ary['id'];
		$obj->name = $ary['name'];
		$obj->email = $ary['email'];
		if (!empty( $ary['real_name'])) {
			$obj->real_name = $ary['real_name'];
		}
		return $obj;
	}
	//AttachmentDataIuWFNgւ̕ϊ
	function mti_convert_to_attachment($ary) {
		$obj = new AttachmentData();
		$obj->id = $ary['id'];
		$obj->size = $ary['size'];
		$obj->content_type = $ary['content_type'];
		$obj->date_submitted = $ary['date_submitted'];
		$obj->download_url = $ary['download_url'];
		return $obj;
	}
	//AttachmentDataXgւ̕ϊ
	function mti_explode_to_attachment($ary) {
		$result = array();
		foreach( $ary as $row ) {
			$result[] = mti_convert_to_attachment($row);
		}
		return $result;
	}
	
	//RelationshipDataIuWFNgւ̕ϊ
	function mti_convert_to_relationships($ary) {
		$obj = new RelationshipData();
		$obj->id = $ary['id'];
		$obj->type = mti_convert_to_objectref($ary['type']);
		$obj->target_id = $ary['target_id'];
		return $obj;
	}
	//RelationshipDataIuWFNgXgւ̕ϊ
	function mti_explode_to_relationships($ary) {
		$result = array();
		foreach( $ary as $row ) {
			$result[] = mti_convert_to_relationships($row);
		}
		return $result;
	}
	
	//IssueNoteDataIuWFNgւ̕ϊ
	function mti_convert_to_issuenotedata($ary) {
		$obj = new IssueNoteData();
		$obj->id = $ary['id'];
		if (!empty( $ary['reporter'])) {
			$obj->reporter = mti_convert_to_accountdata($ary['reporter']);
		}
		$obj->text = $ary['text'];
		$obj->view_state = mti_convert_to_objectref($ary['view_state']);
		$obj->date_submitted = $ary['date_submitted'];
		$obj->last_modified = $ary['last_modified'];
		return $obj;
	}
	//IssueNoteDataIuWFNgXgւ̕ϊ
	function mti_explode_to_issuenotedata($ary) {
		$result = array();
		foreach( $ary as $row ) {
			$result[] = mti_convert_to_issuenotedata($row);
		}
		return $result;
	}
	
	//CustomFieldValueForIssueDataIuWFNgւ̕ϊ
	function mti_convert_to_custom_field($ary) {
		$obj = new CustomFieldValueForIssueData();
		$obj->field = mti_convert_to_objectref($ary['field']);
		$obj->value = $ary['value'];
		return $obj;
	}
	//CustomFieldValueForIssueDataIuWFNgXgւ̕ϊ
	function mti_explode_to_custom_field($ary) {
		$result = array();
		foreach( $ary as $row ) {
			$result[] = mti_convert_to_custom_field($row);
		}
		return $result;
	}
	
	#ObjectRef̔zɕϊ
	function mti_explode_to_objectref( $p_config_enum_string ) {
		
		if( get_class( $p_config_enum_string ) == 'soap_fault' ) {
			throw $p_config_enum_string;
		}
		
		foreach( explode_enum_string( $p_config_enum_string ) as $t_enum_element ) {
			$tmp = new ObjectRef();
			list($tmp->id, $tmp->name) = explode_enum_arr( $t_enum_element );
			$t_result[] = $tmp;
		}
		
		return $t_result;
	}
	
	
	
	/********************************************************************/
	/* IuWFNgzւ̕ϊ                                     */
	/********************************************************************/
	
	function mti_parse_IssueData_to_array($issue) {
		#f[^̓]s
		$result = array();
		
		$result['id'] = $issue->id;
		$result['view_state'] = mti_objectref_to_array($issue->view_state);
		$result['last_updated'] = $issue->last_updated;
		
		$result['project'] = mti_objectref_to_array($issue->project);
		$result['category'] = $issue->category;
		$result['priority'] = mti_objectref_to_array($issue->priority);
		$result['severity'] = mti_objectref_to_array($issue->severity);
		$result['status'] = mti_objectref_to_array($issue->status);
		
		$result['reporter'] = mti_accountdata_to_array($issue->reporter);
		$result['summary'] = $issue->summary;
		$result['version'] = $issue->version;
		$result['build'] = $issue->build ;
		
		$result['platform'] = $issue->platform;
		$result['os'] = $issue->os;
		$result['os_build'] = $issue->os_build;
		$result['reproducibility'] = mti_objectref_to_array($issue->reproducibility);
		$result['date_submitted'] = $issue->date_submitted;
		
		$result['sponsorship_total'] = $issue->sponsorship_total;
		
		$result['handler'] = mti_accountdata_to_array($issue->handler);
		$result['projection'] = mti_objectref_to_array($issue->projection);
		$result['eta'] = mti_objectref_to_array($issue->eta);
		
		$result['resolution'] = mti_objectref_to_array($issue->resolution);
		$result['fixed_in_version'] = $issue->fixed_in_version;
		
		$result['description'] = $issue->description;
		$result['steps_to_reproduce'] = $issue->steps_to_reproduce;
		$result['additional_information'] = $issue->additional_information;
		
		$result['attachments'] = mti_objectlist_to_array($issue->attachments, 'mti_attachmentdata_to_array');
		$result['relationships'] = mti_objectlist_to_array($issue->relationships, 'mti_relationshipdata_to_array');
		$result['notes'] = mti_objectlist_to_array($issue->notes, 'mti_issuenotedata_to_array');
		$result['custom_fields'] = mti_objectlist_to_array($issue->custom_fields, 'mti_customfieldvalueforissuedata_to_array');
		
		return $result;
	}
	
	#ObjectRefarrayɕϊ
	function mti_objectref_to_array($objref) {
		if (empty($objref)) {
			return array('id' => 0, 'name' => '');
		}
		return array('id' => $objref->id, 'name' => $objref->name);
	}
	
	#AccountDataarrayɕϊ
	function mti_accountdata_to_array($obj) {
		if (empty($obj)) {
			return array('id' => 0, 'name' => '', 'real_name' => '', 'email' => '');
		}
		return array('id' => $obj->id, 'name' => $obj->name, 'real_name' => $obj->real_name, 'email' => $obj->email);
	}
	
	#AttachmentDataarrayɕϊ
	function mti_attachmentdata_to_array($obj) {
		if (empty($obj)) {
			return array('id' => 0, 'filename' => '', 'size' => 0, 'content_type' => '', 'date_submitted' => '', 'download_url' => '');
		}
		return array('id' => $obj->id, 'filename' => $obj->filename, 'size' => $obj->size, 'content_type' => $obj->content_type, 'date_submitted' => $obj->date_submitted, 'download_url' => $obj->download_url);
	}
    		
	#RelationshipDataarrayɕϊ
	function mti_relationshipdata_to_array($obj) {
		if (empty($obj)) {
			return array('id' => 0, 'type' => null, 'target_id' => 0);
		}
		return array('id' => $obj->id, 'type' => mti_objectref_to_array($obj->type), 'target_id' => $obj->target_id);
	}
    
	#IssueNoteDataarrayɕϊ
	function mti_issuenotedata_to_array($obj) {
		if (empty($obj)) {
			return array('id' => 0, 'reporter' => null, 'text' => '', 'view_state' => null, 'date_submitted' => '', 'last_modified' => '');
		}
		return array('id' => $obj->id,		'reporter' => mti_accountdata_to_array($obj->reporter),
					 'text' => $obj->text,	'view_state' => mti_objectref_to_array($obj->view_state),
					 'date_submitted' => $obj->date_submitted, 'last_modified' => $obj->last_modified);
	}
	
	#CustomFieldValueForIssueDataarrayɕϊ
	function mti_customfieldvalueforissuedata_to_array($obj) {
		if (empty($obj)) {
			return array('field' => null, 'value' => '');
		}
		return array('field' => mti_objectref_to_array($obj->field), 'value' => $obj->value);
	}
	
	function mti_objectlist_to_array($obj, $fun) {
		$result = array();
		
		if (empty($obj)) {
			return $result;
		}
		
		foreach( $obj as $row ) {
			$result[] = call_user_func_array($fun, array($row));
		}
		
		return $result;
	}
	
	//tϊ(ۗ)
	function timestamp_to_iso8601($v) {
		return $v;
	}
?>